[PATCH mtd-utils 02/11] tests: ubifs_repair: Add authentication refusing test

From: Zhihao Cheng
Date: Wed Dec 27 2023 - 20:33:58 EST


Authenticated UBIFS image is not support for UBIFS repair, add testcase
to check that.

Signed-off-by: Zhihao Cheng <chengzhihao1@xxxxxxxxxx>
---
.gitignore | 1 +
configure.ac | 3 +-
tests/ubifs_repair-tests/Makemodule.am | 3 +-
.../tests/authentication_refuse.sh.in | 69 ++++++++++++++++++++++
4 files changed, 74 insertions(+), 2 deletions(-)
create mode 100755 tests/ubifs_repair-tests/tests/authentication_refuse.sh.in

diff --git a/.gitignore b/.gitignore
index c811883..7613349 100644
--- a/.gitignore
+++ b/.gitignore
@@ -113,6 +113,7 @@ tests/fs-tests/stress/fs_stress01.sh
tests/ubi-tests/runubitests.sh
tests/ubi-tests/ubi-stress-test.sh
tests/ubifs_repair-tests/lib/common.sh
+tests/ubifs_repair-tests/tests/authentication_refuse.sh

#
# Files generated by autotools
diff --git a/configure.ac b/configure.ac
index d3d3589..a42a55d 100644
--- a/configure.ac
+++ b/configure.ac
@@ -355,6 +355,7 @@ AC_CONFIG_FILES([tests/fs-tests/fs_help_all.sh
tests/fs-tests/stress/fs_stress01.sh
tests/ubi-tests/runubitests.sh
tests/ubi-tests/ubi-stress-test.sh
- tests/ubifs_repair-tests/lib/common.sh])
+ tests/ubifs_repair-tests/lib/common.sh
+ tests/ubifs_repair-tests/tests/authentication_refuse.sh])

AC_OUTPUT([Makefile])
diff --git a/tests/ubifs_repair-tests/Makemodule.am b/tests/ubifs_repair-tests/Makemodule.am
index caa503d..c0a6ea1 100644
--- a/tests/ubifs_repair-tests/Makemodule.am
+++ b/tests/ubifs_repair-tests/Makemodule.am
@@ -1,2 +1,3 @@
test_SCRIPTS += \
- tests/ubifs_repair-tests/lib/common.sh
+ tests/ubifs_repair-tests/lib/common.sh \
+ tests/ubifs_repair-tests/tests/authentication_refuse.sh
diff --git a/tests/ubifs_repair-tests/tests/authentication_refuse.sh.in b/tests/ubifs_repair-tests/tests/authentication_refuse.sh.in
new file mode 100755
index 0000000..b322121
--- /dev/null
+++ b/tests/ubifs_repair-tests/tests/authentication_refuse.sh.in
@@ -0,0 +1,69 @@
+#!/bin/sh
+# Copyright (c), 2023-2024, Huawei Technologies Co, Ltd.
+# Author: Zhihao Cheng <chengzhihao1@xxxxxxxxxx>
+#
+# Test Description:
+# Refuse repairing authenticated UBIFS image
+# Running time: 10s
+
+TESTBINDIR=@TESTBINDIR@
+source $TESTBINDIR/common.sh
+
+ID="0xec,0xa1,0x00,0x15" # 128M 128KB 2KB 512-sub-page
+
+function run_test()
+{
+ echo "Do authentication_refused test"
+
+ modprobe nandsim id_bytes=$ID
+ mtdnum="$(find_mtd_device "$nandsim_patt")"
+ flash_eraseall /dev/mtd$mtdnum
+
+ modprobe ubi mtd="$mtdnum,2048,0,0,1" fm_autoconvert || fatal "modprobe ubi fail"
+ ubimkvol -N vol_test -m -n 0 /dev/ubi$UBI_NUM || fatal "mkvol fail"
+ modprobe ubifs || fatal "modprobe ubifs fail"
+
+ mount_ubifs $DEV $MNT "authentication" || fatal "mount ubifs failed"
+ fsstress -d $MNT/fsstress -l0 -p4 -n10000 &
+ sleep $((RANDOM % 5))
+
+ ps -e | grep -w fsstress > /dev/null 2>&1
+ while [ $? -eq 0 ]
+ do
+ killall -9 fsstress > /dev/null 2>&1
+ sleep 1
+ ps -e | grep -w fsstress > /dev/null 2>&1
+ done
+
+ while true
+ do
+ res=`mount | grep "$MNT"`
+ if [[ "$res" == "" ]]
+ then
+ break;
+ fi
+ umount $MNT
+ sleep 0.1
+ done
+
+ echo 'format "UBIFS DBG repair" +pflmt' > /sys/kernel/debug/dynamic_debug/control
+ echo "$DEV" > /sys/kernel/debug/ubifs/repair_fs
+ res=$?
+ if [[ $res == 0 ]]
+ then
+ fatal "repair should not be success!"
+ fi
+
+ check_memleak
+
+ modprobe -r ubifs
+ modprobe -r ubi
+ modprobe -r nandsim
+}
+
+start_t=$(date +%s)
+run_test
+end_t=$(date +%s)
+time_cost=$(( end_t - start_t ))
+echo "Success, cost $time_cost seconds"
+exit 0
--
2.13.6